//************************************************//
//                                                //
//    Programme pour régler le Lecteur Sonore     //
//  relié à une carte ARDUINO via le port Série   //
//                                                //
//           avec le logiciel PROCESSING          //
//    compatible Windows, Mac, Linux, Raspberry   //
//                                                //
//             UAICF Nevers-Vauzelles             //
//           http://modelisme58.free.fr           //
//                                                //
//           Juillet 2019 - Version 1.0           //
//                                                //
//************************************************//

void setup() 
{
  size(800, 600);

  Ecran_Larg = 800;
  Ecran_Haut = 600;

  ImageFond = loadImage("data/fond.png");
  image (ImageFond, 0, 0, Ecran_Larg, Ecran_Haut);

  ImageLogoUAICF = loadImage("data/logo-UAICF.png"); 
  ImageAccueil = loadImage("data/accueil.jpg"); 

  PoliceBouton = createFont("data/polices/ARLRDBD.ttf", 10);
  PolicePresentation = createFont("data/polices/ARLRDBD.ttf", 12);
  PoliceArret = createFont("data/polices/fontawesome-webfont.ttf", 40); 
  PoliceIcone = createFont("data/polices/fontawesome-webfont.ttf", 25);
  PoliceTitre1 = createFont("data/polices/ARLRDBD.ttf", 20);
  PoliceTitre2 = createFont("data/polices/ARLRDBD.ttf", 14);
  PoliceTitre3 = createFont("data/polices/ARLRDBD.ttf", 13);
  PoliceTitre4 = createFont("data/polices/ARLRDBD.ttf", 10);

  CreationBoutons();

  PortCOM();

  if (NbrePort >0)   SelectPort.show();
}

void draw()
{
  image (ImageFond, 0, 0, Ecran_Larg, Ecran_Haut);

  DebutImpression();

  textFont(PoliceTitre1);
  fill (bleu);
  text("Réglage du Lecteur Sonore connecté à une carte ARDUINO", Xmin-40, 15+15);
  textFont(PoliceTitre2);
  fill (blanc);
  text("Compatible avec la version V2 du programme de commande du lecteur sonore MP3", Xmin-40, 43+15);
  text("développée par la section Modélisme de l'UAICF Nevers-Vauzelles", Xmin-40, 63+15);
  fill(bleu);
  text("Retrouvez les projets sur http://modelisme58.free.fr", Xmin-20, 580);
  image (ImageLogoUAICF, 10, 22, 180/4, 229/4);

  ModeImpression();

  if (PortConnecte == true)
  {
    RecupConfig.show();
    TexteRecupConfig.show();
    if (InitialisationPort == false)
    {
      fill(blanc);
      strokeWeight(0);
      rect(Xmin+40-3, Ymin, 239+5, 425+5);
      image (ImageAccueil, Xmin+40, Ymin+3, 239, 425);
    }

    fill(CouleurFond);

    Presentation
      .setPosition(530, 350)
      .setSize(230, 200)
      ;

  } else {
    fill(blanc);
    strokeWeight(0);
    rect(Xmin+40-3, Ymin, 239+5, 425+5);
    image (ImageAccueil, Xmin+40, Ymin+3, 239, 425);
    RecupConfig.hide();
    TexteRecupConfig.hide();

    Presentation
      .setPosition(530, 185)
      .setSize(260, 380)
      ;
    NomPDF.hide();
    CreationPDF.hide();
    ModeImpresssion = false;
    ModeImpresssionOk = false;
    ImprimerPDF.hide();
    BtNiveauSonorePlus .hide();
    BtNiveauSonoreMoins .hide();
    BtNiveauSonoreInter .hide();
    BtAdresseDCCPlus1 .hide();
    BtAdresseDCCPlus10.hide();
    BtAdresseDCCInter.hide();
    BtAdresseDCCMoins1.hide();
    BtAdresseDCCMoins10.hide();
    BtConfigDCCPlus1.hide();
    BtConfigDCCPlus10.hide();
    BtConfigDCCInter.hide();
    BtConfigDCCMoins1.hide();
    BtConfigDCCMoins10.hide();
    BtNbreSonsPlus.hide();
    BtNbreSonsInter.hide();
    BtNbreSonsMoins.hide();
    BtNum1Plus.hide();
    BtNum1Inter.hide();
    BtNum1Moins.hide();
    BtNbSonsAleaPlus.hide();
    BtNbSonsAleaInter.hide();
    BtNbSonsAleaMoins.hide();
    BtTpsMiniPlus1.hide();
    BtTpsMiniPlus10.hide();
    BtTpsMiniInter.hide();
    BtTpsMiniMoins1.hide();
    BtTpsMiniMoins10.hide();
    BtTpsMaxiPlus1.hide();
    BtTpsMaxiPlus10.hide();
    BtTpsMaxiInter.hide();
    BtTpsMaxiMoins1.hide();
    BtTpsMaxiMoins10.hide();
    TexteSelectSonA.hide();
    TexteSelectSonM.hide();
    SliderSelectSonAleatoire.hide();
    SliderSelectSonManuel.hide();
    BtJouerM.hide();
    BtJouerA.hide();
    TexteNiveauSonore.hide();
    TexteAdresseDCC1.hide();
    TexteConfigDCC.hide();
    TexteNbreSonsM.hide();
    TexteNbreSonsA.hide();
    TexteNumSon1A.hide();
    TexteTempsMini.hide();
    TexteTempsMaxi.hide();
    BtEnvoiConfig.hide();
    IconLecture.hide();
    IconAleatoire.hide();
    TexteLecture.hide();
    TexteAleatoire.hide();
  }

  AffichageBoutonConnecte();

  textFont(PoliceTitre2);
  fill (blanc);
  text("Retrouvez les projets sur http://modelisme58.free.fr", Xmin-20, 580);

  if (ModeImpresssion == false)
  {
    AfficherConfiguration();
  } else {
    AfficherConfigurationImpression();
  }
}

void mousePressed()
{
  if (mouseX > Xmin && mouseX < Xmin+310 && mouseY > 570 && mouseY <570+20) 
  {
    link("http://modelisme58.free.fr");
  }
}
