//*** Réception des données sur le port série ***

void serialEvent(Serial myPort)
{
  /*
   C : Configuration
   a : Adresse DCC pour commandes des sons
   b : Adresse DCC pour configuration
   d : Durée mini en secondes entre 2 sons joués en mode aléatoire
   e : Durée maxi en secondes entre 2 sons joués en mode aléatoire
   f : Active / désactive le mode aléatoire
   g : Nombre de sons joués en mode aléatoire
   j : Joue un fichier son
   l : Mode lecture / pause
   n : Nombre de sons joués en mode manuel
   p : Numéro du premier son joué en mode aléatoire
   v : Niveau sonore
   s : Joue le son Précédent / Suivant
   Z : Type de centrale
   */

  while (myPort.available() > 0)
  {
    int c = myPort.read();
    NbreCaractere++;
    /*
    print("c = ");    
     println(c);
     */

    if (c > 47 && c < 58)
    {
      EntreeCaractere =  EntreeCaractere * 10 + c - 48;
    }

    if (c == 36 && NbreCaractere == 1) // Caractère $
    {
      ValideConsigne = true;
    }

    if (NbreCaractere == 2)
    {

      switch (c)
      {
      case 'j':             // Caractère j
        SelectionChar = 2;
        break;

      case 'v':             // Caractère v
        SelectionChar = 3;
        break;

      case 'f':             // Caractère f
        SelectionChar = 4;
        break;

      case 'n':             // Caractère n
        SelectionChar = 5;
        break;

      case 'g':             // Caractère g
        SelectionChar = 6;
        break;

      case 'a':             // Caractère a
        SelectionChar = 7;
        break;

      case 'b':             // Caractère b
        SelectionChar = 8;
        break;

      case 'p':             // Caractère p
        SelectionChar = 9;
        break;

      case 'd':             // Caractère d
        SelectionChar = 10;
        break;

      case 'e':             // Caractère e
        SelectionChar = 11;
        break;

      case 'l':             // Caractère l
        SelectionChar = 12;
        break;

      case 's':             // Caractère s
        SelectionChar = 13;
        break;

      case 'Z':                  // Caractère Z
        SelectionChar = 14;
        break;
      }
    }


    if (c == 10 || c == 13)
    {
      if (ValideConsigne == true)
      {
        int ValeurRecue;

        switch (SelectionChar)
        {
        case 2: //*** Joue un son en mode manuel
          break;


        case 3: //*** Niveau sonore du lecteur MP3 (entre 0 et 30)
          NiveauSonore = EntreeCaractere;
          if (NiveauSonore > 30) 
          {
            NiveauSonore = 30;
            if (ConnexionPortCOM== true)
            {
              Mon_Port_COM.write("$v"+NiveauSonore+"\n");
            }
          }

          if (NiveauSonore < 0)
          {
            NiveauSonore = 0;
            if (ConnexionPortCOM== true)
            {
              Mon_Port_COM.write("$v"+NiveauSonore+"\n");
            }
          }

          // print("Niveau Sonore = "); println(NiveauSonore);
          TexteNiveauSonore
            .setValue(str(NiveauSonore))
            .setColorBackground(vert)
            .setColorForeground(vert);
          ModifParametres&= ~(1 << 1);
          break;


        case 4: //*** Mode Manuel ou Aleatoire
          Mode_Aleatoire = EntreeCaractere;
          if (Mode_Aleatoire > 1 || Mode_Aleatoire < 0 ) 
          {
            Mode_Aleatoire = 0;
            if (ConnexionPortCOM== true)
            {
              Mon_Port_COM.write("$f"+Mode_Aleatoire+"\n");
            }
          }
          if (Mode_Aleatoire == 1)
          {
            TexteAleatoire
              .setText("Mode Aleatoire activé");
          } else {
            TexteAleatoire
              .setText("Mode Manuel");
          }
          //  print("Mode Aleatoire = "); println(Mode_Aleatoire);
          break;


        case 5: //*** Nombre de Sons en mode Manuel
          NbreSonsManuel = EntreeCaractere;
          if (NbreSonsManuel > 255 || NbreSonsManuel < 0 ) 
          {
            NbreSonsManuel = 5;
            if (ConnexionPortCOM== true)
            {
              Mon_Port_COM.write("$n"+NbreSonsManuel+"\n");
            }
          }

          //print("Nbre de sons en mode Manuel = "); println(NbreSonsManuel);
          TexteNbreSonsM
            .setValue(str(NbreSonsManuel))
            .setColorBackground(vert)
            .setColorForeground(vert);
          ModifParametres&= ~(1 << 4);
          SliderSelectSonManuel
            .setValue(NbreSonsManuel/2)
            .setRange(1, NbreSonsManuel);
          break;


        case 6: //*** Nombre de Sons en mode Aleatoire
          NbreSonsAleatoire = EntreeCaractere;
          if (NbreSonsAleatoire > 255 || NbreSonsAleatoire < 0 ) 
          {
            NbreSonsAleatoire = 5;
            if (ConnexionPortCOM== true)
            {
              Mon_Port_COM.write("$g"+NbreSonsAleatoire+"\n");
            }
          }

          //print("Nbre de sons en mode Aleatoire = "); println(NbreSonsAleatoire);
          TexteNbreSonsA
            .setValue(str(NbreSonsAleatoire))
            .setColorBackground(vert)
            .setColorForeground(vert);
          ModifParametres&= ~(1 << 6);

          int  NumSonMAleatoire = NumSon1Aleatoire + NbreSonsAleatoire/2;
          SliderSelectSonAleatoire
            .setValue(NumSonMAleatoire )
            .setRange(NumSon1Aleatoire, NumSon1Aleatoire+NbreSonsAleatoire);
          break;


        case 7: //*** Adresse DCC du Son 1 en mode manuel
          AdresseDCC1 = EntreeCaractere;
          if (AdresseDCC1  > 9999 || AdresseDCC1  < 1 ) 
          {
            AdresseDCC1 = 5;
            if (ConnexionPortCOM== true)
            {
              Mon_Port_COM.write("$a"+AdresseDCC1+"\n");
            }
          }

          //  print("Adresse DCC du Son 1 en mode manuel = "); println(AdresseDCC1);
          TexteAdresseDCC1
            .setValue(str(AdresseDCC1))
            .setColorBackground(vert)
            .setColorForeground(vert);
          ModifParametres&= ~(1 << 2);
          break;


        case 8: //*** Adresse DCC pour gestion des sons
          ConfigDCC = EntreeCaractere;
          if (ConfigDCC > 9999 || ConfigDCC < 1 ) 
          {
            ConfigDCC = 15;
            if (ConnexionPortCOM== true)
            {
              Mon_Port_COM.write("$b"+ConfigDCC+"\n");
            }
          }

          // print("Adresse DCC pour gestion des Sons = "); println(ConfigDCC);
          TexteConfigDCC
            .setValue(str(ConfigDCC))
            .setColorBackground(vert)
            .setColorForeground(vert);
          ModifParametres&= ~(1 << 3);
          break;


        case 9: //*** Numero du premier son en mode aléatoire
          NumSon1Aleatoire = EntreeCaractere;
          if (NumSon1Aleatoire > 9999-5 || NumSon1Aleatoire < 1 ) 
          {
            NumSon1Aleatoire = 1;
            if (ConnexionPortCOM== true)
            {
              Mon_Port_COM.write("$p"+NumSon1Aleatoire+"\n");
            }
          }

          //  print("Numero du premier fichier en mode Aleatoire = "); println(NumSon1Aleatoire);
          TexteNumSon1A
            .setValue(str(NumSon1Aleatoire))
            .setColorBackground(vert)
            .setColorForeground(vert);
          ModifParametres&= ~(1 << 5);

          NumSonMAleatoire = NumSon1Aleatoire + NbreSonsAleatoire/2;
          SliderSelectSonAleatoire
            .setValue(NumSonMAleatoire )
            .setRange(NumSon1Aleatoire, NumSon1Aleatoire+NbreSonsAleatoire);
          break;


        case 10:  //*** Tps Mini en secondes entre 2 fichiers Son en mode aleatoire
          if (EntreeCaractere > 0)
          {
            Interval_AleatoireB = EntreeCaractere;
          }
          // print("Tps Mini en secondes entre 2 fichiers Son en mode aleatoire = "); println(Interval_AleatoireB);
          TexteTempsMini
            .setValue(str(Interval_AleatoireB))
            .setColorBackground(vert)
            .setColorForeground(vert);
          ModifParametres&= ~(1 << 7);
          break;


        case 11:  //*** Tps Maxi en secondes entre 2 fichiers Son en mode aleatoire
          if (EntreeCaractere > 1)
          {
            Interval_AleatoireH = EntreeCaractere;
          }
          //  print("Tps Maxi en secondes entre 2 fichiers Son en mode aleatoire = "); println(Interval_AleatoireH);
          TexteTempsMaxi
            .setValue(str(Interval_AleatoireH))
            .setColorBackground(vert)
            .setColorForeground(vert);
          ModifParametres&= ~(1 << 8);
          break;


        case 12:
          Mode_Lecture = EntreeCaractere;
          if (Mode_Lecture  > 1 || Mode_Lecture  < 0 ) 
          {
            Mode_Lecture = 0;
            if (ConnexionPortCOM== true)
            {
              Mon_Port_COM.write("$l"+Mode_Lecture +"\n");
            }
          }
          if (Mode_Lecture == 1)
          {
            TexteLecture
              .setText("Mode Pause")
              .setPosition(550, 255)
              .setColorValue(rouge);
          } else {
            TexteLecture
              .setText("Mode Lecture")
              .setPosition(550, 255)
              .setColorValue(blanc);
          }
          //  print("Mode Manuel = "); println(Mode_Lecture);
          break;


        case 13:
          break;

        case 14: //*** Détermine le type de centrale DCC
          if (EntreeCaractere == 0 || EntreeCaractere == 1)
          {
            Mode_Centrale = EntreeCaractere;
          }
          if (Mode_Centrale == 1)
          {
            TexteCentrale.setText("Centrale LENZ");
          } else {
            TexteCentrale.setText("Centrale ROCO, NanoX, ...");
          }
          break;
        }
      }

      //*** Remise à zéro des variables ***
      EntreeCaractere = 0;
      SelectionChar = 0;
      NbreCaractere = 0;
      ValideConsigne = false;
    }
  }
}
